VERSION 5.00
Object = "{5E9E78A0-531B-11CF-91F6-C2863C385E30}#1.0#0"; "msflxgrd.ocx"
Begin VB.Form Form1 
   Caption         =   "Msflexgrid with controls"
   ClientHeight    =   7215
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   9300
   KeyPreview      =   -1  'True
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   7215
   ScaleWidth      =   9300
   StartUpPosition =   2  'CenterScreen
   Begin VB.CheckBox chk1 
      Height          =   195
      Left            =   6900
      TabIndex        =   2
      Top             =   2460
      Visible         =   0   'False
      Width           =   195
   End
   Begin VB.TextBox Text1 
      Alignment       =   2  'Center
      Appearance      =   0  'Flat
      BorderStyle     =   0  'None
      Height          =   195
      Left            =   4440
      TabIndex        =   1
      Text            =   "Text1"
      Top             =   3600
      Width           =   1455
   End
   Begin MSFlexGridLib.MSFlexGrid grid 
      Height          =   6615
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   8775
      _ExtentX        =   15478
      _ExtentY        =   11668
      _Version        =   393216
      Rows            =   26
      Cols            =   20
      AllowBigSelection=   0   'False
      ScrollTrack     =   -1  'True
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'Row where the chekbox must take over
Private Const rc As Integer = 8
Dim boolval(1) As String
Dim nVisibleCols As Integer
Dim nVisibleRows As Integer
Dim tx As Integer, ty As Integer
Private Declare Function GetSystemMetrics Lib "USER32" (ByVal nIndex As Long) As Long
Private Const SM_CXVSCROLL = 2
Private Const SM_CYHSCROLL = 3
Private Const SM_CYBORDER = 6
'Height of a horizontal scrollbar
Dim VSC_H As Long
'Border thickness of a horizontal scrollbar
Dim VSC_B As Long
'This variable is set tells the scroll event handler
'that scrolling has been triggered indirectly by a
'keystroke or mouse click
Dim IndirectScroll As Boolean
Private Sub Form_Load()
    chk1.Visible = False
    Text1.Visible = False
    Text1.BackColor = vbYellow
    boolval(1) = "Enabled"
    boolval(0) = "Disabled"
    tx = Screen.TwipsPerPixelX
    ty = Screen.TwipsPerPixelY
    IndirectScroll = False
    initgrid
End Sub
Private Sub Form_Activate()
    grid_EnterCell
End Sub
Private Sub initgrid()
    Dim i As Integer, j As Integer
    Dim WeirdValue
    
    WeirdValue = 2
    nVisibleRows = 0
    nVisibleCols = 0
    Randomize
    With grid
        For i = 0 To .Rows - 1
            .TextMatrix(i, 0) = Val(i)
        Next
        For i = 1 To .Cols - 1
            .TextMatrix(0, i) = Val(i)
            If .ColIsVisible(i) Then nVisibleCols = nVisibleCols + 1
        Next
        For i = 1 To .Rows - 1
            For j = 1 To .Cols - 1
                If i = rc Then
                    .TextMatrix(i, j) = Trim$(boolval(Int(Rnd * 2)))
                Else
                    .TextMatrix(i, j) = Trim$(Int(Rnd * 1001))
                End If
            Next
            If .RowIsVisible(i) Then nVisibleRows = nVisibleRows + 1
        Next
        .ColAlignment(-1) = flexAlignCenterCenter
        'Grid width computation:
        'Sum of the widths of all columns plus
        'the right and left border widths
        '(borderwidth = 2*BorderStyle, found by trial and error) plus
        '3 pixels (found by trial and error): these are necessary to avoid
        'strange behaviour when scrolling (try other values and see...)
        .Width = .ColWidth(0) * nVisibleCols + 4 * .BorderStyle * tx + 2 * tx + tx
        VSC_H = GetSystemMetrics(SM_CYHSCROLL) * tx
        VSC_B = GetSystemMetrics(SM_CYBORDER) * ty
        .Height = .RowHeight(0) * 26 + 4 * .BorderStyle * tx + VSC_H + WeirdValue * VSC_B
        .HighLight = flexHighlightNever
        .FocusRect = flexFocusNone
    End With
End Sub
Private Sub grid_Scroll()
    If IndirectScroll Then
        IndirectScroll = False
        Exit Sub
    End If
    With grid
        If NotQuiteVisible(grid, .Col) Then
        'If Not (.RowIsVisible(.Row) And .ColIsVisible(.Col)) Then
            chk1.Visible = False
            Text1.Visible = False
        ElseIf .Row = rc Then
            SetUpCheckBox
        Else
            SetUpTextBox
        End If
    End With
End Sub
Private Function NotQuiteVisible(g As MSFlexGrid, c As Integer) As Boolean
    If c = g.LeftCol Then
        NotQuiteVisible = False
    Else
        NotQuiteVisible = g.ColPos(c) <= g.ColWidth(0) Or g.ColPos(c) + g.ColWidth(0) >= g.Width
    End If
End Function
Private Sub grid_EnterCell()
    grid.CellBackColor = vbYellow
    If grid.Row = rc Then SetUpCheckBox Else SetUpTextBox
End Sub
Private Sub grid_LeaveCell()
    'Set flag to indicate that any possible scrolling
    'is triggered by the user's changing cell (by means
    'of a key stroke or a mouse event) and so avoid
    'unwanted effects due to scroll event handler calling
    If grid.Row = rc Then IndirectScroll = True
    With grid
        If .Row = rc Then
            .TextMatrix(.Row, .Col) = Trim$(boolval(chk1.Value))
            chk1.Visible = False
        Else
            .TextMatrix(.Row, .Col) = Text1.Text
            Text1.Visible = False
        End If
        .CellBackColor = vbWindowBackground
    End With
End Sub
Private Sub grid_KeyPress(KeyAscii As Integer)
    If grid.Row = rc Then
        If KeyAscii = vbKeySpace Then
            chk1.Value = Abs(Not CBool(chk1.Value))
        ElseIf KeyAscii = vbKeyReturn Then
            grid.Row = grid.Row + 1
            KeyAscii = 0
        End If
    End If
End Sub
Private Sub SetUpCheckBox()
    With grid
        chk1.Left = .Left + .CellLeft + (.ColWidth(.Col) - chk1.Width) \ 2
        'chk1.Top = .Top + .RowPos(.Row) + (.RowHeight(.Row) - chk1.Height) \ 2
        chk1.Top = .Top + .CellTop + (.RowHeight(.Row) - chk1.Height) \ 2
        Select Case .TextMatrix(.Row, .Col)
            Case boolval(0)
                chk1.Value = 0
            Case boolval(1)
                chk1.Value = 1
        End Select
        .Text = ""
        Text1.Visible = False
        chk1.Visible = True
    End With
End Sub
Private Sub SetUpTextBox()
    With grid
        Text1.Text = .TextMatrix(.Row, .Col)
        Text1.Width = .ColWidth(.Col) - tx * .BorderStyle
        Text1.Height = .RowHeight(.Row) - ty * .BorderStyle
        'Text1.Move .Left + .CellLeft, .Top + .RowPos(.Row) + (.RowHeight(.Row) - Text1.Height) \ 2 ', .ColWidth(.Col) - 15, .RowHeight(.Row) - 15
        Text1.Move .Left + .CellLeft, .Top + .CellTop '+ (.RowHeight(.Row) - Text1.Height) \ 2
        Text1.SelStart = 0
        Text1.SelLength = Len(Text1.Text)
        chk1.Visible = False
        Text1.Visible = True
        Text1.SetFocus
    End With
End Sub
Private Sub chk1_Click()
    grid.SetFocus
End Sub
Private Sub Text1_KeyDown(KeyCode As Integer, Shift As Integer)
    With grid
        Select Case KeyCode
            Case vbKeyReturn
                If .Row < .Rows - 1 Then
                    .Row = .Row + 1
                ElseIf .Col < .Cols - 1 Then
                    .Col = .Col + 1
                    .Row = 1
                End If
            Case vbKeyLeft
                .Col = .Col + (.Col > 1)
            Case vbKeyRight
                .Col = .Col - (.Col < .Cols - 1)
            Case vbKeyUp
                .Row = .Row + (.Row > 1)
            Case vbKeyDown
                .Row = .Row - (.Row < .Rows - 1)
            Case Else
                Exit Sub
        End Select
        KeyCode = 0
    End With
End Sub
Private Sub Text1_KeyPress(KeyAscii As Integer)
    If KeyAscii = vbKeyReturn Then KeyAscii = 0
End Sub
